/*
 *  TOPPERS/OSEK Kernel
 *      Toyohashi Open Platform for Embedded Real-Time Systems/
 *      OSEK Kernel
 * 
 *  Copyright (C) 2004-2006 by Witz Corporation, JAPAN
 * 
 *  L쌠҂́Cȉ (1)`(4) ̏CFree Software Foundation 
 *  ɂČ\Ă GNU General Public License  Version 2 ɋL
 *  qĂ𖞂ꍇɌC{\tgEFAi{\tgEFA
 *  ς̂܂ށDȉjgpEEρEĔzziȉC
 *  pƌĂԁj邱Ƃ𖳏ŋD
 *  (1) {\tgEFA\[XR[ȟ`ŗpꍇɂ́CL̒
 *      \C̗pщL̖ۏ؋K肪Ĉ܂܂̌`Ń\[
 *      XR[hɊ܂܂Ă邱ƁD
 *  (2) {\tgEFACCu`ȂǁC̃\tgEFAJɎg
 *      pł`ōĔzzꍇɂ́CĔzzɔhLgip
 *      ҃}jAȂǁjɁCL̒쌠\C̗pщL
 *      ̖ۏ؋Kfڂ邱ƁD
 *  (3) {\tgEFAC@ɑgݍނȂǁC̃\tgEFAJɎg
 *      płȂ`ōĔzzꍇɂ́Ĉꂩ̏𖞂
 *      ƁD
 *    (a) ĔzzɔhLgip҃}jAȂǁjɁCL̒
 *        쌠\C̗pщL̖ۏ؋Kfڂ邱ƁD
 *    (b) Ĕzž`ԂCʂɒ߂@ɂāCTOPPERSvWFNg
 *        񍐂邱ƁD
 *  (4) {\tgEFA̗pɂ蒼ړI܂͊ԐړIɐ邢Ȃ鑹
 *      QCL쌠҂TOPPERSvWFNgƐӂ邱ƁD
 * 
 *  {\tgEFÁCۏ؂Œ񋟂Ă̂łDL쌠҂
 *  TOPPERSvWFNǵC{\tgEFAɊւāC̓Kp\
 *  ܂߂āCȂۏ؂sȂD܂C{\tgEFA̗pɂ蒼
 *  ړI܂͊ԐړIɐȂ鑹QɊւĂC̐ӔC𕉂ȂD
 * 
 */

/*
 *	Tv^[QbgˑVXe^C}W[iCQ7144Apj
 */


#include	"hw_sys_timer.h"


/*
 *  VXe^C}̋N
 *
 *  ݋֎~ԂŌďoƁD
 */
void
InitHwSysTimer( void )
{
	/*
	 *  CMTW[X^oC
	 */
	MSTCR2 &= (UINT16)~0x1000;		/* CMTL */
	
	/*
	 *  RyA}b`^C}~ĊeWX^ݒ
	 *  RyA}b`^C}0gpD
	 */
	CMSTR &= (UINT16)~0x0001;		/* JEg~ */

	/*
	 *   ӃNbN 1/8, 荞݋֎~
	 *  CMCSR  bit7 ݗvtOłCɃNAĂD
	 */
	CMCSR_0 = (UINT16)0x0000;

	/*
	 *  Ry}b`JE^ڕWlݒ
	 */
	CMCOR_0 = CFG_SYSCLK;

	/*
	 *  ^C}RyA݃xݒiݒ背x̓wb_QƁj
	 */
	IPRG = (UINT16)((IPRG & ~(0xFu << 4)) | (CFG_INTLVL_SYSCLK << 4));

	/*
	 *  JE^NAƊ݋
	 */
	CMCNT_0 = (UINT16)0x0000;		/* JEgNA */
	CMCSR_0 |= (UINT16)0x0040;		/* RyA}b`݋ */

	CMSTR |= (UINT16)0x0001;		/* JEgJn */

}	/* InitHwSysTimer	*/


/*
 *  VXe^C}̒~
 *
 *  ݋֎~ԂŌďoƁD
 */
void
TermHwSysTimer( void )
{
	CMSTR &= (UINT16)~0x0001;		/* JEg~ */
	CMCSR_0 = (UINT16)0x0000;		/* @\ */
}	/* TermHwSysTimer	*/


